apiVersion: tekton.dev/v1beta1
kind: Task
metadata:
  labels:
    {{ network_policy_deployment_label }}: job-{{ tekton_name }}
    version: "{{ tekton_assets_version }}"
  name: ansible-runner
  namespace: {{ buildns }}
spec:
  params:
  - name: args
    description: The arguments to pass ansible-runner
    type: array
    default:
    - --help
  - name: project-dir
    description: The project directory under the workspace runner-dir
    default: project
  steps:
  - image: {{ (opsimages | json_query("[?name=='awx_runner'].image"))[0] }}
    name: generate-image-build-assets
{% if tekton_uses_resources_limits | default(False) %}
    resources:
      limits:
        cpu: "{{ tekton_awxrunner_cpu_limit }}"
        memory: {{ tekton_awxrunner_memory_limit }}
      requests:
        cpu: "{{ tekton_awxrunner_cpu_request }}"
        memory: {{ tekton_awxrunner_memory_request }}
{% else %}
    resources: {}
{% endif %}
    script: |
      #!/bin/sh
{% if do_debugs %}
      set -xe;
{% else %}
      set -e;
{% endif %}

      if test -f requirements.txt; then
          pip3 install --user -r requirements.txt;
      fi;
      if test -f  requirements.yml; then
          ansible-galaxy role install -vv -r requirements.yml;
          ansible-galaxy collection install -vv -r requirements.yml;
      elif test -f  requirements.yaml; then
          ansible-galaxy role install -vv -r requirements.yaml;
          ansible-galaxy collection install -vv -r requirements.yaml;
      fi
{% if k8s_flavor == 'kubernetes' %}
    securityContext:
      runAsUser: {{ k8s_unprivileged_userid }}
{% endif %}
    workingDir: '$(workspaces.runner-dir.path)/$(params.project-dir)'
  - args:
    - ansible-runner
    - run
    - $(params.args)
    - $(params.project-dir)
    command: ['entrypoint']
    image: {{ (opsimages | json_query("[?name=='awx_runner'].image"))[0] }}
    name: build
    resources:
      limits:
        cpu: "{{ tekton_awxrunner_cpu_limit }}"
        memory: {{ tekton_awxrunner_memory_limit }}
      requests:
        cpu: "{{ tekton_awxrunner_cpu_request }}"
        memory: {{ tekton_awxrunner_memory_request }}
    workingDir: '$(workspaces.runner-dir.path)'
{% if k8s_flavor == 'kubernetes' %}
    securityContext:
      runAsUser: {{ k8s_unprivileged_userid }}
{% endif %}
  workspaces:
  - name: runner-dir
    description: The Ansibler runner directory
